var g = Object.defineProperty;
var w = (o, t, a) => t in o ? g(o, t, { enumerable: !0, configurable: !0, writable: !0, value: a }) : o[t] = a;
var u = (o, t, a) => (w(o, typeof t != "symbol" ? t + "" : t, a), a);
class p extends Error {
  constructor(a, e, r, s) {
    super(a);
    u(this, "chunkedFile");
    u(this, "response");
    u(this, "originalError");
    this.chunkedFile = e, this.response = r, this.originalError = s;
  }
}
function m(o, t, a, e) {
  let r = 0, s = t;
  const n = [];
  for (; r < o.size; )
    n.push({ blob: o.slice(r, s), index: n.length, isUploaded: !1, uploaded: 0 }), r = s, s = r + t;
  return {
    chunks: n,
    originalFile: o,
    uid: a,
    callback: e
  };
}
async function c(o, t, a, e) {
  let r;
  if (e.setFormData)
    r = e.setFormData(t, a);
  else {
    r = new FormData();
    const l = new Blob([t.blob], { type: a.originalFile.type });
    r.append("file", l, a.originalFile.name), r.append("metadata.uploadUid", a.uid), r.append("metadata.chunkIndex", t.index.toString()), r.append("metadata.totalChunks", a.chunks.length.toString()), r.append("metadata.totalFileSize", a.originalFile.size.toString());
  }
  const s = new XMLHttpRequest(), n = await new Promise((l) => {
    s.upload.addEventListener("progress", (d) => {
      d.lengthComputable && (t.uploaded = t.blob.size < d.loaded ? t.blob.size : d.loaded, a.callback && a.callback(b(a), a.uid));
    }), s.addEventListener("loadend", () => {
      l(s.readyState === 4 && Math.floor(s.status / 100) === 2);
    }), s.open("POST", o, !0), e.headers.Authorization && s.setRequestHeader("Authorization", e.headers.Authorization), s.send(r);
  }), i = JSON.parse(s.response);
  if (n)
    return t.isUploaded = !0, i;
  throw t.isUploaded = !1, t.uploaded = 0, new p("Upload failed", a, i);
}
async function f(o, t, a) {
  try {
    const e = t.chunks.filter((i) => !i.uploaded), r = e.length;
    r >= 2 && await c(o, e[0], t, a);
    const s = e.slice(1, -1).map((i) => c(o, i, t, a));
    await Promise.all(s);
    const n = await c(o, e[r - 1], t, a);
    if (!n)
      throw new p("Failed to upload", t);
    return {
      result: n,
      file: t.originalFile,
      uid: t.uid
    };
  } catch (e) {
    throw e instanceof p ? e : e instanceof Error ? new p(e.message, t, void 0, e) : new p("No actual error was thrown", t);
  }
}
function b(o) {
  return o.chunks.reduce((a, e) => a + e.uploaded, 0) / o.originalFile.size;
}
const h = 5 * 1024 * 1024;
function z(o, t = {}) {
  const e = {
    ...{
      chunkSize: h,
      headers: {},
      progressPollInterval: 500
    },
    ...t
  };
  async function r(n, i, l) {
    const d = m(n, e.chunkSize, i, l);
    return f(o, d, e);
  }
  async function s(n) {
    return f(o, n, e);
  }
  return { uploadFile: r, retryUpload: s };
}
export {
  p as UploadFailedError,
  z as useChunkUpload
};
